import { jsx as _jsx } from "react/jsx-runtime";

/* eslint-disable no-console */
import PropTypes from 'prop-types';
import ReactDOM from 'react-dom';
import Context from '@s-ui/react-context';
import { useMount } from '@s-ui/react-hooks';

function renderWidgetOnDOM(_ref) {
  var children = _ref.children,
      context = _ref.context,
      node = _ref.node;
  ReactDOM.render( /*#__PURE__*/_jsx(Context.Provider, {
    value: context,
    children: children
  }), node);
}

export default function Widget(_ref2) {
  var children = _ref2.children,
      _ref2$context = _ref2.context,
      context = _ref2$context === void 0 ? {} : _ref2$context,
      _ref2$isVisible = _ref2.isVisible,
      isVisible = _ref2$isVisible === void 0 ? true : _ref2$isVisible,
      selector = _ref2.selector,
      _ref2$renderMultiple = _ref2.renderMultiple,
      renderMultiple = _ref2$renderMultiple === void 0 ? false : _ref2$renderMultiple;
  useMount(function () {
    if (!selector) {
      return console.warn("[Widget] You must define a selector to use the Widget");
    }

    var nodes = document.querySelectorAll(selector);

    if (!nodes.length) {
      return console.warn("[Widget] unable find nodes using selector " + selector);
    } // depending on renderMultiple, get the full array or only the first one


    var nodesToRender = renderMultiple ? [].slice.call(nodes) : [nodes[0]];
    isVisible && nodesToRender.map(function (node) {
      return renderWidgetOnDOM({
        children: children,
        context: context,
        node: node
      });
    });
  });
  return null;
}
Widget.propTypes = {
  children: PropTypes.element.isRequired,
  context: PropTypes.object,
  isVisible: PropTypes.bool,
  selector: PropTypes.string.isRequired
};